--[[
 					Cultivator Unia Mars 4m.
 ___________________________________________________________________
|-------------------------------------------------------------------|
|======================== Unia Mars 4m =============================|
|-------------------------------------------------------------------|
|			Copyright (C) Majster, All Rights Reserved				|
|-------------------------------------------------------------------|
|						Date: 14.05.2010                			|
|-------------------------------------------------------------------|
|....................www.majster-mod.xaa.pl.........................|
|------------------------------------------------------------------	|
|___________________________________________________________________|
]]--

Unia_Mars = {};
--------------------------------------------------------------------------------
function Unia_Mars.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Trailer, specializations);

end;
--==============================================================================
function Unia_Mars:load(xmlFile)


	-------------------------------Animacja-------------------------------------
	self.connectCollisions = SpecializationUtil.callSpecializationsFunction("connectCollisions");
	self.anim = SpecializationUtil.callSpecializationsFunction("anim");
	self.Go = {};
	self.Done = {};
	self.charId = {};
	self.clipIndex = {};
	self.CheckDone = {};
	self.moveColli = {};
    self.animParts = {};
	self.collisionArm = {};
	self.startpoint = {};
	self.loopCheck = {};
	self.Speed = {};
	local count = getXMLInt(xmlFile, "vehicle.animParts#count");
	local part = self.animParts;
    for i=1, count do
		part[i] = {};
        local partname = string.format("vehicle.animParts.part".."%d", i);
	    local nameR = getXMLString(xmlFile, partname.."#name");
		self.charId[nameR] = Utils.indexToObject(self.components, getXMLString(xmlFile, partname.."#rootNode"));
		self.clipIndex[nameR] = getXMLString(xmlFile, partname.."#animationClip");
		self.CheckDone[nameR] = false;
		self.moveColli[nameR] = getXMLString(xmlFile, partname.."#moveColli");
		self.startpoint[nameR] = Utils.getNoNil(getXMLFloat(xmlFile, partname.."#startpoint"),0.0);
		if self.moveColli[nameR] ~= nil then
			local Collision = {};
			Collision.collision = Utils.indexToObject(self.components, getXMLString(xmlFile, partname.."#collision"));
			Collision.collisionAttacher = Utils.indexToObject(self.components, getXMLString(xmlFile, partname.."#collsionAttacher"));
			Collision.armAttacher = Utils.indexToObject(self.components, getXMLString(xmlFile, partname.. "#armAttacher"));
			Collision.index = 0;
			self.collisionArm[nameR] = Collision;
			self:connectCollisions(nameR);
		end;
		local charId = getAnimCharacterSet(self.charId[nameR]);
		local clipIndex = getAnimClipIndex(charId, self.clipIndex[nameR]);
		assignAnimTrackClip(charId , 0, clipIndex);
		setAnimTrackTime(charId, 0, self.startpoint[nameR]);
		enableAnimTrack(charId, 0);
		disableAnimTrack(charId, 0);
		self.loopCheck[nameR] = false;
		self.Speed[nameR] = 1.0;
	end;
	----------------------------Animacja----------------------------------------


	-------------------------------Obszar---------------------------------------
	local numCuttingAreas = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.cuttingAreas#count"), 0);
    for i=1, numCuttingAreas do
        local areanamei = string.format("vehicle.cuttingAreas.cuttingArea%d", i);
        self.cuttingAreas[i].foldMinLimit = Utils.getNoNil(getXMLFloat(xmlFile, areanamei .. "#foldMinLimit"), 0);
        self.cuttingAreas[i].foldMaxLimit = Utils.getNoNil(getXMLFloat(xmlFile, areanamei .. "#foldMaxLimit"), 1);
    end;
	-------------------------------Obszar---------------------------------------


	---------------------------------Walki--------------------------------------
	self.speedRotatingParts = {};
    local i = 0;
    while true do
        local baseName = string.format("vehicle.speedRotatingParts.speedRotatingPart(%d)", i);
        local index = getXMLString(xmlFile, baseName.. "#index");
        if index == nil then
            break;
        end;
        local node = Utils.indexToObject(self.components, index);
        if node ~= nil then
            local entry = {};
            entry.node = node;
            entry.rotationSpeedScale = getXMLFloat(xmlFile, baseName.."#rotationSpeedScale");
            if entry.rotationSpeedScale == nil then
                entry.rotationSpeedScale = 1.0/Utils.getNoNil(getXMLFloat(xmlFile, baseName.."#radius"), 1);
            end;

			local wheel = Utils.indexToObject(self.components, getXMLString(xmlFile, baseName.. "#wheel"));
			if wheel ~= nil then
				entry.isWheel = true;
				entry.wheel = wheel;
				entry.wheelContactGround = false;
			else
				entry.isWheel = false;
			end;

            entry.foldMinLimit = Utils.getNoNil(getXMLFloat(xmlFile, baseName .. "#foldMinLimit"), 0);
            entry.foldMaxLimit = Utils.getNoNil(getXMLFloat(xmlFile, baseName .. "#foldMaxLimit"), 1);

            table.insert(self.speedRotatingParts, entry);
        end;
        i = i + 1;
    end;
	------------------------------Walki-----------------------------------------


	----------------------------------Kurz--------------------------------------
	self.groundParticleSystems = {};
    local psName = "vehicle.groundParticleSystem";
    Utils.loadParticleSystem(xmlFile, self.groundParticleSystems, psName, self.components, false, nil, self.baseDirectory)
    self.groundParticleSystemActive = false;
	-----------------------------Kurz--------------------------------


	-----------------------------Dzwiek uprawy----------------------------------

	local kosiarkaSound = getXMLString(xmlFile, "vehicle.kosiarkaSound#file");
    if kosiarkaSound ~= nil and kosiarkaSound ~= "" then
        kosiarkaSound = Utils.getFilename(kosiarkaSound, self.baseDirectory);
        self.kosiarkaSound = createSample("kosiarkaSound");
        self.kosiarkaSoundEnabled = false;
        loadSample(self.kosiarkaSound, kosiarkaSound, false);
        self.kosiarkaSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.kosiarkaSound#pitchOffset"), 1);
        self.kosiarkaSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.kosiarkaSound#volume"), 1);
    end;

	-----------------------------Dzwiek uprawy----------------------------------


	--------------------------Kontakt z terenem---------------------------------
	self.groundReferenceThreshold = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.groundReferenceNode#threshold"), 0.2);
	self.groundReferenceNode = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.groundReferenceNode#index"));
	---------------------------Kontakt z terenem--------------------------------
end;
--==============================================================================
function Unia_Mars:delete()
 delete(self.upraSound); -- Usuwanie dzwiekow
end;
--==============================================================================
function Unia_Mars:mouseEvent(posX, posY, isDown, isUp, button)
end;
--==============================================================================
function Unia_Mars:keyEvent(unicode, sym, modifier, isDown)
end;
--==============================================================================
function Unia_Mars:update(dt)



	if self:getIsActive() then --Aktywna maszyna


	------------------------Kontakt z terenem-----------------------------------
		if not hasGroundContact then
            if self.groundReferenceNode ~= nil then
                local x,y,z = getWorldTranslation(self.groundReferenceNode);
                local terrainHeight = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x, 0, z);
                if terrainHeight+self.groundReferenceThreshold >= y then
                    hasGroundContact = true;
                end;
            end;
        end;
	------------------------Kontakt z terenem-----------------------------------


	--------------------------------Walki---------------------------------------
		for i = 1, table.getn(self.speedRotatingParts) do
			if self.speedRotatingParts[i].isWheel then
				if not self.speedRotatingParts[i].wheelContactGround then
					local x,y,z = getWorldTranslation(self.speedRotatingParts[i].wheel);
					local terrainHeight = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x, 0, z);
					if terrainHeight + self.groundReferenceThreshold >= y then
						self.speedRotatingParts[i].wheelContactGround = true;
					end;
				end;
			end;
		end;
	---------------------------------Walki--------------------------------------


	--------------------------------Uprawa--------------------------------------
		 if hasGroundContact then
			local x,y,z = getWorldTranslation(self.groundReferenceNode); -- Kontakt z terenem
            local terrainHeight = getTerrainHeightAtWorldPos(g_currentMission.terrainRootNode, x, 0.0, z); -- Kontakt z terene
			if terrainHeight+self.groundReferenceThreshold >= y then
				local x,y,z = getWorldTranslation(cuttingAreas[1].start);
				local x1,y1,z1 = getWorldTranslation(cuttingAreas[1].width);
				local x2,y2,z2 = getWorldTranslation(cuttingAreas[1].height);
				Utils.updateCultivatorArea(x, z, x1, z1, x2, z2);
	------------------------------Aktywacja kurzu-------------------------------
			if self.lastSpeed*3600 > 5 and not self.groundParticleSystemActive then
                self.groundParticleSystemActive = true;
                Utils.setEmittingState(self.groundParticleSystems, true);
            end;
	        if self.lastSpeed*3600 < 5 and self.groundParticleSystemActive then
                self.groundParticleSystemActive = false;
                Utils.setEmittingState(self.groundParticleSystems, false);
            end;
		else
			if self.groundParticleSystemActive then
                self.groundParticleSystemActive = false;
                Utils.setEmittingState(self.groundParticleSystems, false);
			end;
	------------------------------Aktywacja kurzu-------------------------------


	---------------------------Aktywacja drzwieku-------------------------------
			  if self.lastSpeed*3600 > 3 then
				if not self.kosiarkaSoundEnabled and self:getIsActiveForSound() then
                setSamplePitch(self.kosiarkaSound, self.kosiarkaSoundPitchOffset);
                playSample(self.kosiarkaSound, 0, self.kosiarkaSoundVolume, 0);
                self.kosiarkaSoundEnabled = true;
            end;
			  end;
			  if self.lastSpeed*3600 < 3 then
				if not self.kosiarkaSoundEnabled and self:getIsActiveForSound() then
                setSamplePitch(self.kosiarkaSound, self.kosiarkaSoundPitchOffset);
                playSample(self.kosiarkaSound, 0, self.kosiarkaSoundVolume, 0);
                self.kosiarkaSoundEnabled = false;
            end;
			  end;
			end;
		end;
    ---------------------------Aktywacja drzwieku-------------------------------

	------------------------------------Uprawa----------------------------------


	--------------Przesuwanie sie komponentow----------------
		if self.Done.kola then
			local joint = self.componentJoints[2]; -- pierwsze kolo
			setJointFrame(joint.jointIndex, 0,joint.jointNode);
			local joint = self.componentJoints[3]; -- drugie kolo
			setJointFrame(joint.jointIndex, 0,joint.jointNode);
		end;
	--------------Przesuwanie sie komponentow----------------


	-----------------Animacja podnoszenia kol---------------------
	if self.Go.kola ~= nil and self.Done.kola ~= false then
		self:anim("kola",false);
	end;
	---------------Przycisk od podnoszenia kol--------------------
	if InputBinding.hasEvent(InputBinding.IMPLEMENT_EXTRA) then
		self.Go.kola = not self.Go.kola;
		self.Done.kola = true;
	end;
	-----------------Animacja podnoszenia kol---------------------


	end; --Aktywna maszyna END
end;
--==============================================================================
function Unia_Mars:draw()

end;
--==============================================================================
function Unia_Mars:onAttach(attacherVehicle)
	self.Go.kola = false
	self.Done.kola = true;
end;
--==============================================================================
function Unia_Mars:onDetach()

end;
function Unia_Mars:onDeactivate()
    Unia_Mars.onDeactivateSounds(self)

    if self.uniaSoundEnabled then
        stopSample(self.uniaSound);
        self.uniaSoundEnabled = false;
    end
   self.isTurnedOn = false;
end;
--==============================================================================
function Unia_Mars:onDeactivateSounds()
    if self.uniaSoundEnabled then
        stopSample(self.uniaSound);
        self.uniaSoundEnabled = false;
    end;
end;
--==============================================================================
function Unia_Mars:anim(varName, loopCheck)
	if self.moveColli[varName] ~= nil then
		local Collision = self.collisionArm[varName];
		setJointFrame(Collision.index, 0, Collision.armAttacher);
	end;
	local loopCheck = self.loopCheck[varName];
	local speed = Utils.getNoNil(self.Speed[varName],1);
	local offset = 10;
	local charId = getAnimCharacterSet(self.charId[varName]);
	local clipIndex = getAnimClipIndex(charId, self.clipIndex[varName]);
	if self.Done[varName] ~= false then
		if self.Go[varName] == true then
			assignAnimTrackClip(charId , 0, clipIndex);
			setAnimTrackLoopState(charId, 0, loopCheck);
			setAnimTrackSpeedScale(charId, 0, speed);
			enableAnimTrack(charId, 0);
			if getAnimTrackTime(charId, 0) >= getAnimClipDuration(charId, clipIndex) and loopCheck == false then
				self.Done[varName] = false;
				self.CheckDone[varName] = self.Go[varName];
			end;
			if getAnimTrackTime(charId, 0) >= getAnimClipDuration(charId, clipIndex) and loopCheck then
				local setTime = getAnimClipDuration(charId, clipIndex) - getAnimClipDuration(charId, clipIndex);
				setAnimTrackTime(charId, 0, setTime);
			end;
		elseif self.Go[varName] == false then
			if loopCheck == true then
				self.Done[varName] = false;
			else
				assignAnimTrackClip(charId , 0, clipIndex);
				setAnimTrackLoopState(charId, 0, loopCheck);
				setAnimTrackSpeedScale(charId, 0, -speed);
				enableAnimTrack(charId, 0);
				if getAnimTrackTime(charId, 0) <= 0 then
					self.Done[varName] = false;
					self.CheckDone[varName] = self.Go[varName];
				end;
			end;
		elseif self.Go[varName] ~= nil then
			assignAnimTrackClip(charId , 0, clipIndex);
			setAnimTrackLoopState(charId, 0, loopCheck);
			if self.Go[varName] < 0.0 then
				self.Go[varName] = 0.0;
			elseif self.Go[varName] > getAnimClipDuration(charId, clipIndex) then
				self.Go[varName] = getAnimClipDuration(charId, clipIndex);
			end;
			if getAnimTrackTime(charId, 0) >= self.Go[varName] then
				setAnimTrackSpeedScale(charId, 0, -speed);
			else
				setAnimTrackSpeedScale(charId, 0, speed);
			end;
			enableAnimTrack(charId, 0);
			if getAnimTrackTime(charId, 0) <= self.Go[varName] + offset and getAnimTrackTime(charId, 0) >= self.Go[varName] - offset then
				self.Done[varName] = false;
				self.CheckDone[varName] = self.Go[varName];
			end;
		end;
	end;
	if self.Done[varName] == false then
		disableAnimTrack(charId, 0);
	end;
end;
--==============================================================================
function Unia_Mars:connectCollisions(varName)
	local Collision = self.collisionArm[varName];
	local constr = JointConstructor:new();
	constr:setActors(self.rootNode, Collision.collision);
	constr:setJointTransforms(Collision.armAttacher, Collision.collisionAttacher);
	for i=1, 3 do
		constr:setRotationLimit(i-1, 0, 0, 0);
		constr:setTranslationLimit(i-1, true, 0, 0);
	end;
	Collision.index = constr:finalize();
end;
